uses RTC_MAIN,RTC_BR,RTC_ERR,crt;

var
    Code:string;
    CodePtr:pointer;
    CodeSize:word;
    MyFunc: function (x,y:float):float;
    err,errp:integer;

function sh(x:float):float;far;
begin
  sh:=(exp(x)-exp(-x))*0.5;
end;

function ch(x:float):float;far;
begin
  ch:=(exp(x)+exp(-x))*0.5;
end;


procedure InitCode(s:string);
var SC:PSmallCompiler;
begin
  SC:=New(PCompilerForBorlandReal,Init(
          Var_('x',
          Var_('y',
          Function_('sh',@sh,
          Function_('ch',@ch,nil))))));

  with SC^ do
    begin
    SetData(s,err,errp,CodeSize);
    if err<>0 then Error(s,err,errp);
    GetMem(CodePtr,CodeSize);
    GetCode(@MyFunc,CodePtr^);
    end;
  Dispose(SC,Done);
end;


var r:float;
    s:string;
    i:word;
begin
 clrscr;
 InitCode('sh(x)*ch(y)');
 if err=0 then
   begin
   writeln('MyFunc(0,1)=',MyFunc(0,1):0:4);
   writeln('MyFunc(1,2)=',MyFunc(1,2):0:4);
   writeln('MyFunc(1.2,2.3)=',MyFunc(1.2,2.3):0:4);
   end;
 FreeMem(CodePtr,CodeSize);
end.

