uses RTC_MAIN,RTC_BR,RTC_ERR,crt;

var
    Code1,Code2:string;
    CodePtr1,CodePtr2:pointer;
    CodeSize1,CodeSize2:word;
    MyFunc1: function (x:float):float;
    MyFunc2: function (x,y:float):float;
    err1,err2,errp:integer;

function sh(x:float):float;far;
begin
  sh:=(exp(x)-exp(-x))*0.5;
end;

function ch(x:float):float;far;
begin
  ch:=(exp(x)+exp(-x))*0.5;
end;


procedure InitCode1(s:string);
var SC:PSmallCompiler;
begin
  SC:=New(PCompilerForBorlandReal,Init(
          Var_('x',nil)));
  with SC^ do
    begin
    SetData(s,err1,errp,CodeSize1);
    if err1<>0 then Error(s,err1,errp);
    GetMem(CodePtr1,CodeSize1);
    GetCode(@MyFunc1,CodePtr1^);
    end;
  Dispose(SC,Done);
end;

procedure InitCode2(s:string);
var SC:PSmallCompiler;
begin
  SC:=New(PCompilerForBorlandReal,Init(
          Var_('x',
          Var_('y',
          Function_('sh',@sh,
          Function_('ch',@ch,
          Function_('MyFunc',@MyFunc1,nil)))))));

  with SC^ do
    begin
    SetData(s,err2,errp,CodeSize2);
    if err2<>0 then Error(s,err2,errp);
    GetMem(CodePtr2,CodeSize2);
    GetCode(@MyFunc2,CodePtr2^);
    end;
  Dispose(SC,Done);
end;


var r:float;
    s:string;
    i:word;
begin
 clrscr;
 InitCode1('x*10');
 InitCode2('MyFunc(x)+sh(y)^x');
 if (err1=0) and (err2=0) then
   begin
   writeln('MyFunc2(0,1)=',MyFunc2(0,1):0:4);
   writeln('MyFunc2(1,2)=',MyFunc2(1,2):0:4);
   writeln('MyFunc2(1.2,2.3)=',MyFunc2(1.2,2.3):0:4);
   end;
 FreeMem(CodePtr1,CodeSize1);
 FreeMem(CodePtr2,CodeSize2);
end.

